{                          MSCMDS.INC
                           MSINST 4.0
             Copyright (c) 1985, 87 by Borland International, Inc.            }

type
  CommandType =
  (

    {Basic cursor movements}
    CmdLeftChar,              {0. Left character}
    CmdRightChar,             {1. Right character}
    CmdLeftWord,              {2. Left lexeme}
    CmdRightWord,             {3. Right lexeme}
    CmdUpLine,                {4. Up line}
    CmdDownLine,              {5. Down line}
    CmdScrollUp,              {6. Scroll up}
    CmdScrollDown,            {7. Scroll down}
    CmdDownPage,              {8. Down page}
    CmdUpPage,                {9. Up page}

    {Quick movements}
    CmdWindowTopFile,         {10. Top of window}
    CmdWindowBottomFile,      {11. Bottom of window}
    CmdLeftLine,              {12. Cursor to left side}
    CmdRightLine,             {13. Cursor to right side}
    CmdTopScreen,             {14. Top of screen}
    CmdBottomScreen,          {15. Bottom of screen}
    CmdMoveToBegin,           {16. Move to previous BEGIN line}
    CmdMoveToEnd,             {17. Move to previous END line}
    CmdCpgotoln,              {18. Goto line n}
    CmdGotoColumn,            {19. Goto column n}
    CmdGotoWindow,            {20. Goto window n}
    CmdJumpLastPosition,      {21. Previous cursor position}

    {Insertion and deletion}
    CmdUndo,                  {22. Undo last deletion}
    CmdRestoreCurrentLine,    {23. Restore line as on entry}
    CmdTab,                   {24. Tab, either fixed or "smart"}
    CmdInsertCtrlChar,        {25. Insert control character into text}
    CmdNewLine,               {26. New line in text buffer}
    CmdInsertLine,            {27. Insert line}
    CmdDeleteRightChar,       {28. Delete current character}
    CmdDeleteLeftChar,        {29. Delete left character}
    CmdDeleteRightWord,       {30. Delete right lexeme}
    CmdDeleteLineRight,       {31. Delete line right of cursor}
    CmdDeleteLine,            {32. Delete line}
    CmdDelLineNoRecourse,     {33. Delete line, no undo}

    {Find and replace}
    CmdFind,                  {34. Find pattern}
    CmdFindReplace,           {35. Find and replace}
    CmdFindAndMacro,          {36. Search and apply macro at position}
    CmdFindNext,              {37. Find next}

    {Files and DOS interface}
    CmdInvokeDOS,             {38. Invoke a DOS shell}
    CmdBackTab,               {39. Backward tab}
    CmdNewFile,               {40. Edit a new file in current window}
    CmdAbandonFile,           {41. Abandon file}
    CmdReadBlock,             {42. Read file into window}
    CmdSaveFile,              {43. Save file}
    CmdWriteBlock,            {44. Write block to file, not appending}
    CmdSaveQuit,              {45. Save file and exit}

    {Windows}
    CmdAddWindow,             {46. Add second window with same or different file}
    CmdSizeWindow,            {47. Resize current window}
    CmdDoneFile,              {48. Save current file, and get a new one}
    CmdWindowDown,            {49. Switch windows}
    CmdHelpSummary,           {50. Put up a help summary}
    CmdZoomWindow,            {51. Make the current window fill the screen}

    {Blocks}
    CmdBlockBegin,            {52. Begin block}
    CmdBlockEnd,              {53. End block}
    CmdJumpTopOfBlock,        {54. Top of block}
    CmdJumpBottomBlock,       {55. Bottom of block}
    CmdBlockCopy,             {56. Copy block}
    CmdBlockMove,             {57. Move block}
    CmdBlockDelete,           {58. Delete block}
    CmdBlockHide,             {59. Hide/display toggle block}
    CmdBlockWord,             {60. Mark current word as block}

    {Text markers}
    CmdToggleTextMarker,      {61. Toggle text marker display}
    CmdSetMarker0,            {62. Set marker}
    CmdSetMarker1,
    CmdSetMarker2,
    CmdSetMarker3,
    CmdSetMarker4,
    CmdSetMarker5,
    CmdSetMarker6,
    CmdSetMarker7,
    CmdSetMarker8,
    CmdSetMarker9,
    CmdJumpMarker0,           {72. Jump to marker}
    CmdJumpMarker1,
    CmdJumpMarker2,
    CmdJumpMarker3,
    CmdJumpMarker4,
    CmdJumpMarker5,
    CmdJumpMarker6,
    CmdJumpMarker7,
    CmdJumpMarker8,
    CmdJumpMarker9,

    {Macros}
    CmdReadMacroFile,         {82. Load a set of macros from disk}
    CmdWriteMacroFile,        {83. Write current macros to disk}
    CmdToggleMacroRecord,     {84. Toggle macro recording}
    CmdInsertMacro1,          {85. Insert Macro 1 once}
    CmdInsertMacro2,
    CmdInsertMacro3,
    CmdInsertMacro4,
    CmdInsertMacro5,
    CmdInsertMacro6,
    CmdInsertMacro7,
    CmdInsertMacro8,
    CmdInsertMacro9,
    CmdInsertScrapPrompted,   {94. Insert scrap macro n times (prompted)}
    CmdInsertScrap1,          {95. Insert scrap macro 1..9 times}
    CmdInsertScrap2,
    CmdInsertScrap3,
    CmdInsertScrap4,
    CmdInsertScrap5,
    CmdInsertScrap6,
    CmdInsertScrap7,
    CmdInsertScrap8,
    CmdInsertScrap9,

    {Toggles and status}
    CmdSysInfo,               {104. Show system information}
    CmdShowMem,               {105. Show available memory}
    CmdToggleInsert,          {106. Toggle insert mode}
    CmdToggleAutoindent,      {107. Toggle autoindent mode}

    {Text processing}
    CmdToggleCase,            {108. Toggle case of character(s)}
    CmdLowerCase,             {109. Lower case character(s)}
    CmdUpperCase,             {110. Upper case character or block}
    CmdSetRightMargin,        {111. Set the right margin for word wrap and reformat}
    CmdReformParagraph,       {112. Reformat the current paragraph}
    CmdToggleWordWrap,        {113. Toggle word wrap on or off}
    CmdSetLeftMargin,         {114. Set the left margin for word wrap}
    CmdToggleTabLine,         {115. Toggle tab line display on or off}
    CmdInsertUndoBuffer,      {116. Insert undo buffer at cursor}
    CmdToggleJustify,         {117. Toggle right justification}
    CmdTogglePaginate,        {118. Toggle Pagination display}
    CmdToggleAttribute,       {119. Toggle on-screen attribute display}
    CmdCenterLine,            {120. Center the current line in margins}
    CmdSetColors,             {121. Set editor colors}
    CmdSaveDefaults,          {122. Save colors, toggles, etc for new time}

    {Utility Commands}
    CmdPrintFile,             {123. Print a file}
    CmdFlushUndo,             {124. Flush undo buffer}
    CmdUnused4,               {125. For expansion}
    CmdUnused5,               {126. For expansion}
    CmdLogDrive,              {127. Log drive or path}
    CmdDirectory,             {128. Show directory}

    {Additional commands}
    CmdGotoPage,              {129. Go to specified page}
    CmdSetTopMargin,          {130. Set default top margin}
    CmdSetBotMargin,          {131. Set default bottom margin}
    CmdSetPageLength,         {132. Set default page length}
    CmdSetUndoLimit,          {133. Set default undo limit}
    CmdToggleTabExpansion,    {134. Toggle tab expansion on read-in}
    CmdGetDefaultExtension,   {135. Get a new default file extension}

    CmdSetTabLine,            {136. Set the tabs}
    CmdSetTabSize,            {137. Set default tab size}
    CmdSaveTabLine,           {138. Write current tab line into text}
    CmdEditTabLine,           {139. Interactively edit the tabs}
    CmdSetTempMargin,         {140. Set temporary margin for word wrap}
    CmdReformBlock,           {141. Reformat marked block}
    CmdCloseTillLast,         {142. Close window, on last one, enter menus}

    CmdPromptSetMarker,       {143. Prompt for a marker number to set}
    CmdPromptJumpMarker,      {144. Prompt for a marker to jump to}
    CmdPromptInsertMacro,     {145. Prompt for a macro to insert}
    CmdToggleTabMode,         {146. Toggle between fixed and "smart" tabs}
    CmdSetTempAtCursor,       {147. Set temporary margin at current column}
    CmdSetSupportPath,        {148. Set the path to all the support files}
    CmdToggleStripMode,       {149. Toggle high bit stripping on read-in}
    CmdEditMacro,             {150. Edit a macro}
    CmdWriteNamedFile,        {151. Save current window to another file}

    CmdToggleKeyHelp,         {152. Toggle display of keyboard help in menu system}
    CmdWindowUp,              {153. Move to previous window}
    CmdNextSentence,          {154. Next sentence}
    CmdPrevSentence,          {155. Previous sentence}
    CmdRestoreDefaultTabs,    {156. Restore to default (even) tabs}
    CmdWhatFont,              {157. What font is cursor on}
    CmdChooseBold,            {158. Insert Bold toggle}
    CmdChooseDbl,             {159. Insert Doublestrike toggle}
    CmdChooseUnd,             {160. Insert Underscore toggle}
    CmdChooseSup,             {161. Insert Superscript toggle}
    CmdChooseSub,             {162. Insert Subscript toggle}
    CmdChooseAlt1,            {163. Insert Alt1 font toggle}
    CmdChooseAlt2,            {164. Insert Alt2 font toggle}
    CmdToggleRetraceMode,     {165. Toggle snow checking}
    CmdToggleSolidCursor,     {166. Toggle block cursor mode}
    CmdToggleEga43Line,       {167. Toggle EGA 43 line mode}
    CmdMarginRelease,         {168. Set margin release}
    CmdSpellCheck,            {169. Check spelling}

    CmdUnused6,               {170. Not used}

    CmdToggleWriteTabs,       {171. Toggle tabs written to compress output}
    CmdToggleCompressWrap,    {172. Toggle compression prior to wrap}
    CmdToggleInitZoomState,   {173. Toggle default zoom state}

    CmdHelpMenu,              {174. Help summary menu}
    CmdHelpHelp,              {175. Help regarding help system}
    CmdCursorHelp,            {176.}
    CmdQuickHelp,             {177.}
    CmdDeleteHelp,            {178.}
    CmdFindHelp,              {179.}
    CmdFileHelp,              {180.}
    CmdWindowHelp,            {181.}
    CmdBlockHelp,             {182.}
    CmdTextHelp,              {183.}
    CmdTabHelp,               {184.}
    CmdUtilityHelp,           {185.}
    CmdSettingHelp,           {186.}
    CmdSpellingHelp,          {187.}
    CmdMacroHelp,             {188.}
    CmdFormatHelp,            {189.}
    CmdFunctionKeyHelp,       {190.}

    {These four should be kept last}
    CmdMenu,                  {191. Activate the menu system}
    CmdAbort,                 {192. Abort current operation}
    CmdNull,                  {193. No operation indicated}
    CmdNullMain               {194. No op indicated, submenu accessible with no file open}
    );
