{                          MSIVARS.INC
                           MSINST 4.0
             Copyright (c) 1985, 87 by Borland International, Inc.            }

const
  version = '4.00A';         {installation program version number}
  ProgName = 'MS.EXE';       {name of editor}
  TxtFile = 'MS.TXT';        {name of text help file to read}
  HelpFile = 'MS.HLP';       {name of indexed help file to write}
  NameLength = 26;           {Maximum length title for command}
  CmdListBytes = 1024;       {Maximum Number of bytes of installable commands}
  HelpWidth = 60;            {Max line length of help screen}
  HelpHeight = 15;           {Number of rows of help screen}

type
  String255 = string[255];
  Filepath = string[64];
  CommandName = string[NameLength];
  CommandString = string[4];
  PackedCommandList = array[0..CmdListBytes] of Char;

  commandrec =
  record
    name : CommandName;
    main : keyrec;
    alt : keyrec;
  end;

  commandlist = array[CommandType] of commandrec;

  {Color type for installation}
  ColorType = (              {Screen colors}
               TxtColor,     {Text color}
               BlockColor,   {Block color}
               BordColor,    {Window status lines}
               CmdColor,     {Command line color}
               CursorColor,  {Color for solid block cursor, if activated}
               MnColor,      {Normal menu color}
               MfColor,      {Menu frame color}
               MsColor,      {Selected menu item color}
               MhColor,      {Highlighted selection character in menu}
               BoldColor,    {Color for bold attribute}
               DblColor,     {Color for doublestrike attribute}
               UndColor,     {Color for underscore attribute}
               SupColor,     {Color for superscript attribute}
               SubColor,     {Color for subscript attribute}
               Alt1Color,    {Color for alternate 1 attribute - Compressed}
               Alt2Color     {Color for alternate 2 attribute - Italic}
               );

  {Stores screen attributes}
  AttributeArray = array[ColorType] of Byte;

  MInstallRec =              {Must match order of installation area in MSVARS.PAS}
  record
    SaveUndoLimit : Integer;
    DefExtension : string[3];
    SaveTabSize : Integer;
    ReadExpandTabs : Boolean;
    WriteCompressTabs : Boolean;
    SaveDeviceName : Filepath;
    SaveOutputName : Filepath;
    SavePrinterPort : Byte;
    SaveToFile : Boolean;
    SaveFormatState : Boolean;
    SaveStripMode : Boolean;
    SaveSupportPath : Filepath;
    SaveKeyHelpMode : Boolean;
    SaveInitZoomState : Boolean;
    SaveInsertMode : Boolean;
    SaveIndentMode : Boolean;
    SaveWWmode : Boolean;
    SaveJustMode : Boolean;
    SavePageMode : Boolean;
    SaveAttrMode : Boolean;
    SaveFTmode : Boolean;
    SaveTabMode : Boolean;
    SaveLeftMargin : Integer;
    SaveRightMargin : Integer;
    SaveTopMargin : Integer;
    SaveBottomMargin : Integer;
    SavePageLen : Integer;
    SaveCompressWrap : Boolean;
  end;

  SInstallRec =              {Must match order of installation area in SCRN.PAS}
  record
    MonoAttr : AttributeArray;
    ColorAttr : AttributeArray;
    GoodColorCard : Boolean;
    SolidCursor : Boolean;
    Ega43LineMode : Boolean;
  end;

const

  {Marks start of INSTALLATION AREA}
  MIDstring : string[22] = 'MAIN INSTALLATION AREA';

  {Marks start of KEYBOARD INSTALLATION AREA}
  KIDstring : string[26] = 'KEYBOARD INSTALLATION AREA';

  {Marks start of SCREEN INSTALLATION AREA}
  SIDstring : string[24] = 'SCREEN INSTALLATION AREA';
var
  Commands, OrigCommands : commandlist;
  MainDefaults : MInstallRec;
  ScreenDefaults : SInstallRec;
  WP : WindowPtr;
